#!/usr/local/bin/perl

##====================================================================================##
## URLtoSSI for AD-EDIT2 ver1.0
## (c)2008-2010 NorenzPRO Ltd. TakafumiArai 2010/8/5
##
## *.shtmlへ読み込ませる場合は
## <!--#include virtual="./URLtoSSI.cgi"-->
## のSSIタグを貼付けてご利用ください
##====================================================================================##
use CGI::Carp qw(fatalsToBrowser);
use strict;
use Encode;
use LWP::Simple;
our $importUrl;
our $startLine;
our $endLine;
our $datafile;
our $inCharCode;
our $outCharCode;

##=======================================================================================
## このCGIの設定
##=======================================================================================

#★インポートページのURL
#インポートページのURLを、http:// から記述してください。
$importUrl='http://adedit.norenz.net/download/ssinews.cgi';

#★インポート元ページの文字コード
# shiftjis / utf8 
$inCharCode='shiftjis';

#★SSI出力文字コード
# shiftjis / utf8 
$outCharCode='shiftjis';

#★SSI出力範囲
# 行番号で指定
$startLine = 0;
$endLine   = 100;

#★このCGIがSSI出力時に読込むデータファイルのパス
#このファイルが約1時間間隔で自動更新されます。
$datafile='./URLtoSSI.dat';

##=======================================================================================
## メインルーチン
##=======================================================================================
our $marker;
our $line;

##現在時刻
$ENV{'TZ'} = "JST-9"; 
our ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
our $year += 1900;
our $mon++;
our $nyear = sprintf("%02d",$year);
our $nmon = sprintf("%02d",$mon);
our $nmday = sprintf("%02d",$mday);
our $nhour = sprintf("%02d",$hour);
our $nmin = sprintf("%02d",$min);
our $nDate = $nyear.$nmon.$nmday.$nhour.$nmin.'';

#データファイルの更新時間
our ($devNo,$inoNo,$ChMod,$linkLot,$uID,$gID,$rDev,$fSize,$aTime,$mTime,$cTime,$BlkSize,$Blocks) = stat($datafile);
our ($sec,$min,$hour,$day,$mon,$year) = localtime($mTime);
our $year += 1900;
our $mon++;
our $xyear = sprintf("%04d",$year);
our $xmon = sprintf("%02d",$mon);
our $xday = sprintf("%02d",$day);
our $xhour = sprintf("%02d",$hour);
our $xmin = sprintf("%02d",$min);
our $mDate=$xyear.$xmon.$xday.$xhour.$xmin.'';

our $PastTime=$nDate-$mDate;
if ($PastTime >= 100) {
	##URL読込
	my $importBody=get($importUrl);
	Encode::_utf8_off($importBody);
	Encode::from_to($importBody, $inCharCode, 'utf8'); 
	$importBody =~ s/\r\n/\n/g;
	$importBody =~ s/\r/\n/g;
	my @BodyLines=split(/\n/,$importBody);
	my $checkLine=0;
	my $outBody;
	for (@BodyLines) {
		if (($checkLine >= $startLine)&&($checkLine <= $endLine)) {
			$outBody=$outBody.$_."\n";
		}
		$checkLine++;
	}
	
	##データファイル保存
	our $tmpfile = "$$\.tmp";
	open(TMP,">$tmpfile");
	print TMP $outBody;
	close(TMP);
	chmod(0755,$tmpfile);
	rename($tmpfile,$datafile);
}

##データファイル読込出力
our @pageOut;
if (-e $datafile) {
	open(READ,"$datafile");
	@pageOut = <READ>;
	close(READ);
}

print "Content-type: text/html\n\n";
foreach (@pageOut) {
	Encode::from_to($_, 'utf8', $outCharCode); 
	print $_;
}

exit;
##=======================================================================================
